#include "TeaTimer.hpp"

void TeaTimer::init(ContinuousServo *t_servo)
{
    m_servo = t_servo;
}

// Move servo down, start timer.
void TeaTimer::beginSteeping(unsigned long t_steepingDuration)
{
    if (m_isSteeping)
        return;
    m_servo->moveServoForMillisClockwise(2000);
    m_endSteepingTime = millis() + t_steepingDuration;
    m_isSteeping = true;
}

// Move servo up, stop timer immediately.
void TeaTimer::end_steeping()
{
    m_servo->moveServoForMillisCounterClockwise(2000);
    m_isSteeping = false;
}

// Called at start of update.
void TeaTimer::tick()
{
    m_servo->tick();
    if (millis() >= m_endSteepingTime && m_isSteeping)
    {
        end_steeping();
    }
}

unsigned long TeaTimer::remainingSteepTimeSeconds()
{
    return (m_endSteepingTime - millis()) / 1000;
}